<?php  
/*
Plugin Name: Trackrati
Version: 0.2
Plugin URI: http://www.centralscrutinizer.it/en/design/js-php/from-technorati-to-trackrati-1/
Author: Marco Rosella
Author URI: http://www.centralscrutinizer.it/en
Description: Display, in every post, the Technorati's incoming links number.
*/ 

function trackrati($url = null) {
	$api_key = ' ';	//set your Technorati Api Key here
	if ( !$url )
	$url = apply_filters('the_permalink', get_permalink());	
	$queryurl='http://api.technorati.com/cosmos?key='.$api_key.'&url='.$url;
	$cachetime = 9000; 
	$cachedir = 'tracache';	
	$cacheext = 'cache';
	$path = (ABSPATH.'wp-content/plugins/trackrati_wp/'.$cachedir.'/trackrati-'.md5($queryurl).'.'.$cacheext);
	if (file_exists($path) && time() - $cachetime  < filemtime($path) ) {
		$inboundlinks = unserialize(join('', file($path)));
		$cached=1;	
	} else {
		if (!$str = file_get_contents($queryurl,FALSE)){  
		$inboundlinks = '?';
		} else {
		/* //for those with PHP 5 replace the six lines below with this DOM powered lines:		
		$str = new DomDocument();
		$str->load($queryurl); 
		$inboundlinks = $str->getElementsByTagName('inboundlinks')->item(0)->firstChild->nodeValue; 
		//and then delete the 'parsexml($text)' function.*/
		$xmlarray = parsexml($str);
	    $inboundlinks=$xmlarray['tapi'][0]['document']['0']['result']['0']['inboundlinks'];
	}
	$inlinser = serialize($inboundlinks);
	if ($fp = @fopen($path, 'w')) {
		fwrite ($fp, $inlinser, strlen($inlinser));
		fclose($fp);
	}
	$cached=0;
	}
	if(empty($inboundlinks)){ 
		echo '<a href="http://www.technorati.com/search/'.urlencode($url).'" rel="nofollow">Trackrati (?)</a>';
	} else {	
		echo '<a href="http://www.technorati.com/search/'.urlencode($url).'" rel="nofollow">Trackrati ('.$inboundlinks.')</a>';
	}
}
function parsexml($text) {
	$reg_exp = '/<(\w+)[^>]*>(.*?)<\/\\1>/s';
	preg_match_all($reg_exp, $text, $match);
	   foreach ($match[1] as $key=>$val) {
	   if ( preg_match($reg_exp, $match[2][$key]) ) {
		   $array[$val][] = parsexml($match[2][$key]);
	   } else {$array[$val] = $match[2][$key]; }
   }  return $array;
}

?>